UnrealTargets = LibStub("AceAddon-3.0"):NewAddon("UnrealTargets", "AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")

local media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UnrealTargets")
UnrealTargets:Print("Addon Restarted; new options")


UnrealTargets.frame = CreateFrame("Frame", nil, UIParent)
UnrealTargets.frame:SetPoint("CENTER", 265, 100)
UnrealTargets.frame:SetSize(180, 25)
UnrealTargets.frame:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
UnrealTargets.frame:SetBackdropColor(0.5, 0.5, 0.5, 0.3)
UnrealTargets.frame:SetMovable(true)
UnrealTargets.frame:EnableMouse(true)
UnrealTargets.frame:RegisterForDrag("LeftButton")
UnrealTargets.frame:SetScript("OnDragStart", UnrealTargets.frame.StartMoving)
UnrealTargets.frame:SetScript("OnDragStop", UnrealTargets.frame.StopMovingOrSizing)
UnrealTargets.frame.fontname = UnrealTargets.frame:CreateFontString(nil, "OVERLAY", "GameTooltipText")
UnrealTargets.frame.fontname:SetPoint("CENTER", 0, 0)
UnrealTargets.frame.fontname:SetText('UnrealTargets')
UnrealTargets.frame.fontname:SetFont("Fonts\\FRIZQT__.ttf" , 16, "OUTLINE")
UnrealTargets.targetframe = {}
UnrealTargets.debuffs = {}
UnrealTargets.castingspells = {}

function UnrealTargets:update_click(clickbutton, value)
	local myspellname = GetSpellInfo(value) or nil
	local spellid = 0
	value = value or '0'
	if myspellname == nil then
		print('inputerror '..value)
		return false
	else
		_, _, _, _, _, _, spellid = GetSpellInfo(value)
		print(clickbutton..' is now '..myspellname..' spellid: '..spellid)
	end
	--local mymacrotext = "/cast "..myspellname
	if clickbutton == 'left' then
		for i = 1, 20, 1 do
			local unitid = "nameplate"..i
			local mymacrotext = "/cast [@"..unitid.."] "..myspellname
			UnrealTargets.targetframe[unitid]:SetAttribute("macrotext1", mymacrotext);
		end
		for i = 1, 5, 1 do
			local unitid = "boss"..i
			local mymacrotext = "/cast [@"..unitid.."] "..myspellname
			UnrealTargets.targetframe[unitid]:SetAttribute("macrotext1", mymacrotext);
		end
	elseif clickbutton == 'right' then
		for i = 1, 20, 1 do
			local unitid = "nameplate"..i
			local mymacrotext = "/cast [@"..unitid.."] "..myspellname
			UnrealTargets.targetframe[unitid]:SetAttribute("macrotext2", mymacrotext);
		end
		for i = 1, 5, 1 do
			local unitid = "boss"..i
			local mymacrotext = "/cast [@"..unitid.."] "..myspellname
			UnrealTargets.targetframe[unitid]:SetAttribute("macrotext2", mymacrotext);
		end
	else
	end
	return true
end


function UnrealTargets:cut_name(name, ...)
	local max_length = ... or 15
	local length = string.len(name)
	if length > max_length + 2 then
		name = string.sub(name, 0, max_length)
		name = name..".."
	end
	return name
end

local dbDefaults = {
	profile = {
		lock = false,
		mainfont = "Friz Quadrata TT",
		mainfontsize = 16,
		barheight = 22,
		barwidth = 180,
		barfontsize = 6,
		barTexture = [[Interface\FrameGeneral\UI-Background-Rock]],
		barcolor = {1,0,0,1},
		leftclick = 34914,
		rightclick = 585,
	}	
}

function UnrealTargets:OnInitialize()
	
	self.db = LibStub("AceDB-3.0"):New("UnrealTargetsDB", dbDefaults)
	--self.db = self.db1.profile	
	self:OnOptionCreate()
	self:CreateBarTemplates()
end

function UnrealTargets:OnEnable()
	self.frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self.frame:RegisterEvent('NAME_PLATE_UNIT_ADDED')
	self.frame:RegisterEvent('UNIT_HEALTH_FREQUENT')
	self.frame:RegisterEvent('UNIT_AURA')
	self.frame:SetScript('OnEvent', OnEvent)
	self.frame:SetScript("OnUpdate", UnrealTargets_OnUpdate)
end

function UnrealTargets.frame:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	print('combatlog')
end

function UnrealTargets:CreateBarTemplates()
	UnrealTargets.targetframe['nameplate1'] = {}
		for i = 1, 20, 1 do
			local nameplate = 'nameplate'..i
			self:create_frame(nameplate, i)
			for j = 1, 5, 1 do
				self:create_debuffs(nameplate, j)
			end
		end
		for i = 1, 5, 1 do
			local nameplate = 'boss'..i
			self:create_frame(nameplate, -i)
			for j = 1, 5, 1 do
				self:create_debuffs(nameplate, j)
			end
		end
end

function UnrealTargets:create_frame(unitid, i)
	UnrealTargets.targetframe[unitid] = CreateFrame("Button", unitid.."frame" , UnrealTargets.frame, "SecureActionButtonTemplate")
	--UnrealTargets.targetframe[unitid]:SetPoint("CENTER", 0, 0)
	UnrealTargets.targetframe[unitid]:SetAttribute("unit", unitid)
	UnrealTargets.targetframe[unitid]:SetAttribute("type1", "macro")
	UnrealTargets.targetframe[unitid].fontname = UnrealTargets.targetframe[unitid]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].fontname:SetPoint("TOP", 0, 0)
	UnrealTargets.targetframe[unitid].fontname:SetFont("Fonts\\FRIZQT__.ttf",10,"OUTLINE")	
	UnrealTargets.targetframe[unitid].fontname:SetText(unitid)
	UnrealTargets.targetframe[unitid].guid = ''
	local myspellname1 = GetSpellInfo(self.db.profile.leftclick)
	local mymacrotext1 = "/cast [@"..unitid.."] "..myspellname1
	UnrealTargets.targetframe[unitid]:SetAttribute("macrotext1", mymacrotext1);
	UnrealTargets.targetframe[unitid]:SetAttribute("type2", "macro")
	local myspellname2 = GetSpellInfo(self.db.profile.rightclick)
	local mymacrotext2 = "/cast [@"..unitid.."] "..myspellname2
	UnrealTargets.targetframe[unitid]:SetAttribute("macrotext2", mymacrotext2);
	RegisterUnitWatch(UnrealTargets.targetframe[unitid])
	UnrealTargets.targetframe[unitid]:RegisterForClicks( "LeftButtonUp", "MiddleButtonUp", "RightButtonUp", "Button4Up", "Button5Up",
											"Button6Up", "Button7Up", "Button8Up", "Button9Up", "Button10Up",
											"Button11Up", "Button12Up", "Button13Up", "Button14Up", "Button15Up"); 
	UnrealTargets.targetframe[unitid]:SetPoint("TOP", 0, 0-(i-1)*(self.db.profile.barheight+5)-25-5)
	UnrealTargets.targetframe[unitid]:SetSize(self.db.profile.barwidth, self.db.profile.barheight)
	local list = media:List("statusbar")
	local statusbar = list[self.db.profile.barTexture]
	UnrealTargets.targetframe[unitid]:SetBackdrop({ bgFile = [[Interface\FrameGeneral\UI-Background-Rock]]})
	UnrealTargets.targetframe[unitid]:SetBackdropColor(0,0,0,0)--unpack(self.db.profile.barcolor))
	
	UnrealTargets.targetframe[unitid].bar = CreateFrame("StatusBar", 'bar'..unitid, UnrealTargets.targetframe[unitid])
	UnrealTargets.targetframe[unitid].bar:SetStatusBarTexture( media:Fetch("statusbar", statusbar))
	UnrealTargets.targetframe[unitid].bar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	UnrealTargets.targetframe[unitid].bar:SetBackdropBorderColor(1,1,1,1);
	UnrealTargets.targetframe[unitid].bar:SetBackdropColor(1,1,1,0.2);
	UnrealTargets.targetframe[unitid].bar:GetStatusBarTexture():SetHorizTile(false)
	UnrealTargets.targetframe[unitid].bar:SetMinMaxValues(0, 100)
	UnrealTargets.targetframe[unitid].bar:SetValue(100)
	UnrealTargets.targetframe[unitid].bar:SetPoint('CENTER', 0, 0)
	UnrealTargets.targetframe[unitid].bar:SetStatusBarColor(unpack(self.db.profile.barcolor))
	UnrealTargets.targetframe[unitid].bar:SetSize(self.db.profile.barwidth, self.db.profile.barheight)
	UnrealTargets.targetframe[unitid].bar:SetFrameStrata('LOW')
	UnrealTargets.targetframe[unitid].bar.castbar = CreateFrame("StatusBar", 'castbar'..unitid, UnrealTargets.targetframe[unitid].bar)
	UnrealTargets.targetframe[unitid].bar.castbar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	UnrealTargets.targetframe[unitid].bar.castbar:SetBackdrop({
		bgFile = "Interface/Buttons/GreyscaleRamp64",
		edgeFile = "Interface/Buttons/WHITE8X8",
		edgeSize = 1,
	});
	UnrealTargets.targetframe[unitid].bar.castbar:SetBackdropBorderColor(1,1,1,1);
	UnrealTargets.targetframe[unitid].bar.castbar:SetBackdropColor(1,1,1,0.2);
	UnrealTargets.targetframe[unitid].bar.castbar:GetStatusBarTexture():SetHorizTile(false)
	UnrealTargets.targetframe[unitid].bar.castbar:SetMinMaxValues(0, 100)
	UnrealTargets.targetframe[unitid].bar.castbar:SetValue(100)
	UnrealTargets.targetframe[unitid].bar.castbar:SetPoint('BOTTOM', 0, 0)
	UnrealTargets.targetframe[unitid].bar.castbar:SetSize(self.db.profile.barwidth, self.db.profile.barheight)
	UnrealTargets.targetframe[unitid].bar.castbar:SetStatusBarColor(1,0,0)
	UnrealTargets.targetframe[unitid].bar.castbar:Hide()
	local castname, _, icon = GetSpellInfo(740)
	UnrealTargets.targetframe[unitid].bar.castbar.icon = UnrealTargets.targetframe[unitid].bar.castbar:CreateTexture(nil, 'ARTWORK', UnrealTargets.targetframe[unitid].bar.castbar)
	UnrealTargets.targetframe[unitid].bar.castbar.icon:SetTexture(GetSpellTexture(740))
	UnrealTargets.targetframe[unitid].bar.castbar.icon:SetSize(self.db.profile.barwidth*20/25, self.db.profile.barheight*20/25)
	UnrealTargets.targetframe[unitid].bar.castbar.icon:SetPoint('CENTER', UnrealTargets.targetframe[unitid].bar, 'TOPLEFT', self.db.profile.barheight*2/5+1, -self.db.profile.barheight*2/5-1)
	UnrealTargets.targetframe[unitid].bar.castbar.fontname = UnrealTargets.targetframe[unitid].bar.castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].bar.castbar.fontname:SetPoint("TOPLEFT", 1, -1)
	castname = self:cut_name(castname, 16)
	UnrealTargets.targetframe[unitid].bar.castbar.fontname:SetText(castname)
	UnrealTargets.targetframe[unitid].bar.castbar.fontname:SetFont("Fonts\\FRIZQT__.ttf", 30/3-1,"OUTLINE")
	UnrealTargets.targetframe[unitid].bar.castbar.bartime = UnrealTargets.targetframe[unitid].bar.castbar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].bar.castbar.bartime:SetPoint("TOPRIGHT", -1, -1)
	UnrealTargets.targetframe[unitid].bar.castbar.bartime:SetFont("Fonts\\FRIZQT__.ttf",30/3-1,"OUTLINE")
	UnrealTargets.targetframe[unitid].bar.castbar.bartime:SetText('0.0')
	
	
	UnrealTargets.targetframe[unitid].fonthppercent = UnrealTargets.targetframe[unitid]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].fonthppercent:SetPoint("TOPRIGHT", 0, 0)
	UnrealTargets.targetframe[unitid].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",16,"OUTLINE")	
	UnrealTargets.targetframe[unitid].debuffs = {}
end

function UnrealTargets:create_debuffs(unitid, j)
	local name, rank, fileId, castTime, minRange, maxRange, spellId = GetSpellInfo(740)
	local icon = GetSpellTexture(740)
	
	local debuff = 'debuff'..j
	UnrealTargets.targetframe[unitid].debuffs[debuff] = {}
	UnrealTargets.targetframe[unitid].debuffs[debuff] = CreateFrame('Button', 'debuff'..j, UnrealTargets.targetframe[unitid])
	UnrealTargets.targetframe[unitid].debuffs[debuff]:Show()
	UnrealTargets.targetframe[unitid].debuffs[debuff]:SetNormalTexture(icon)
	UnrealTargets.targetframe[unitid].debuffs[debuff]:SetWidth(self.db.profile.barheight)
	UnrealTargets.targetframe[unitid].debuffs[debuff]:SetHeight(self.db.profile.barheight)
	local anocher, _, _, posix, posiy = UnrealTargets.targetframe[unitid]:GetPoint()
	UnrealTargets.targetframe[unitid].debuffs[debuff]:SetPoint(anocher, -self.db.profile.barwidth/2-3-j*(self.db.profile.barheight-2), 0)
	UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration = UnrealTargets.targetframe[unitid].debuffs[debuff]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration:SetPoint("BOTTOMRIGHT", 0, 0)
	UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration:SetText('0')
	UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration:SetFont("Fonts\\FRIZQT__.ttf",self.db.profile.barheight*1/3,"OUTLINE")
	UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount = UnrealTargets.targetframe[unitid].debuffs[debuff]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount:SetPoint("TOPLEFT", 0, 0)
	UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount:SetText('')
	UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount:SetFont("Fonts\\FRIZQT__.ttf",self.db.profile.barheight*1/3,"OUTLINE")
	UnrealTargets.targetframe[unitid].debuffs[debuff]:Hide()
end

function UnrealTargets:OnOptionCreate()
	if UnrealTargets.db.profile.lock then
		UnrealTargets.frame:EnableMouse(false)
		--f.bg:Hide()
		--f.header:Hide()
	end
	self.frame.fontname:SetFont(media:Fetch("font", self.db.profile.mainfont), self.db.profile.mainfontsize, "OUTLINE")
	-- local list = media:List("statusbar")
	-- local statusbar1 = list[self.db.profile.barTexture]
	-- for i = 1, 20, 1 do
		-- local nameplate = 'nameplate'..i
		-- self.targetframe[nameplate]:SetBackdrop({ bgFile = media:Fetch("statusbar", statusbar1)})
		-- self.targetframe[nameplate]:SetBackdropColor(1, 0, 0, 1)
	-- end
	
	self.options = {
		type = 'group',
		name = GetAddOnMetadata("UnrealTargets", "Title"),
		get = function(info)
			return self.db.profile[info[#info]]
		end,
		args = {
			general = {
				type = "group",
				name = L["General"],
				order = 1,
				args = {
					lock = {
						type = "toggle",
						name = L["Lock position"],
						order = 1,
						set = function(info, value)
							self.db.profile.lock = value
							if value then
								self.frame:EnableMouse(false)
								--self.bg:Hide()
								--self.header:Hide()
							else
								self.frame:EnableMouse(true)
								--self.bg:Show()
								--self.header:Show()
							end
						end,
					},
					mainbar = {
						type = "group",
						order = 2,
						inline = true,
						name = 'Mainbar',
						args = {
							mainfont = {
								type = "select",
								name = L["Font"],
								order = 4,
								values = media:List("font"),
								itemControl = "DDI-Font",
								get = function()
									for i, v in next, media:List("font") do
										if v == self.db.profile.mainfont then return i end
									end
								end,
								set = function(info, value)
									local list = media:List("font")
									local font = list[value]
									self.db.profile.mainfont = font
									self.frame.fontname:SetFont(media:Fetch("font", font), self.db.profile.mainfontsize, "OUTLINE")
								end,
							},
							mainfontsize = {
								type = "range",
								name = L["FontSize"],
								order = 5,
								max = 40,
								min = 6,
								step = 1,
								get = function() return self.db.profile.mainfontsize end,
								set = function(info, value)
									self.db.profile.mainfontsize = value
									self.frame.fontname:SetFont(media:Fetch("font", self.db.profile.mainfont), self.db.profile.mainfontsize, "OUTLINE")
								end,
							},
							-- mainfontoutline = {
								-- type = "toggle",
								-- name = L["is outlined"],
								-- order = 6,
								-- set = function(info, value)
									-- self.db.profile.mainfontoutline = value
									-- if value then
										-- self.frame.fontname:SetFont(media:Fetch("font", self.db.profile.mainfont), self.db.profile.fontsize, "OUTLINE")
									-- else
										-- self.frame.fontname:SetFont(media:Fetch("font", self.db.profile.mainfont), self.db.profile.fontsize, nil)
									-- end
									-- --self.db.profile.mainfontoutline = value
									-- --self.frame.fontname:SetFont(media:Fetch("font", self.db.profile.mainfont), self.db.profile.fontsize, "OUTLINE")
								-- end,
							-- },
						},
					},
					baroptions = {
						type = "group",
						order = 5,
						inline = true,
						name = L["Baroptions"],
						args = {
							barheight = {
								type = "range",
								name = L["height"],
								order = 1,
								max = 80,
								min = 6,
								step = 1,
								set = function(info, value)
									self.db.profile.barheight = value
									for i = 1, 20, 1 do
										local nameplate = 'nameplate'..i
										self.targetframe[nameplate]:SetHeight(value)
										self.targetframe[nameplate]:SetPoint("TOP", 0, 0-(i-1)*(value+5)-25-5)
									end
									for i = 1, 5, 1 do
										local nameplate = 'boss'..i
										self.targetframe[nameplate]:SetHeight(value)
										self.targetframe[nameplate]:SetPoint("TOP", 0, 0-(i-1)*(value+5)-25-5)
									end
								end,
							},
							barwidth = {
								type = "range",
								name = L["width"],
								order = 2,
								max = 500,
								min = 20,
								step = 1,
								set = function(info, value)
									self.db.profile.barwidth = value
									for i = 1, 20, 1 do
										local nameplate = 'nameplate'..i
										self.targetframe[nameplate]:SetWidth(value)
									end
									for i = 1, 5, 1 do
										local nameplate = 'boss'..i
										self.targetframe[nameplate]:SetWidth(value)
									end
								end,
							},
							barfontsize = {
								type = "range",
								name = L["FontSize"],
								order = 3,
								max = 40,
								min = 3,
								step = 1,
								get = function() return self.db.profile.barfontsize end,
								set = function(info, value)
									self.db.profile.barfontsize = value
									for i = 1, 20, 1 do
										local nameplate = 'nameplate'..i
										self.targetframe[nameplate].fontname:SetFont("Fonts\\FRIZQT__.ttf", value,"OUTLINE")	
									end
									for i = 1, 5, 1 do
										local nameplate = 'boss'..i
										self.targetframe[nameplate].fontname:SetFont("Fonts\\FRIZQT__.ttf", value,"OUTLINE")	
									end
								end,
							},
							barTexture = {
								type = "select",
								name = L["Texture"],
								desc = "Set the bar texture.",
								order = 4,
								values = media:List("statusbar"),
								itemControl = "DDI-Statusbar",
								get = function()
									for i, v in next, media:List("statusbar") do
										if v == self.db.profile.barTexture then return i end
									end
								end,
								set = function(info, value)
									self.db.profile.barTexture = value
									local list = media:List("statusbar")
									local statusbar = list[value]
									self.db.profile.barTexture = statusbar
									for i = 1, 20, 1 do
										local nameplate = 'nameplate'..i
										self.targetframe[nameplate].bar:SetStatusBarTexture(media:Fetch("statusbar", statusbar))
									end
									for i = 1, 5, 1 do
										local nameplate = 'boss'..i
										self.targetframe[nameplate].bar:SetStatusBarTexture(media:Fetch("statusbar", statusbar))
									end
								end,
							},
							barcolor = {
								type = "color",
								name = L["Color"],
								hasAlpha = true,
								order = 5,
								get = function()
									return unpack(self.db.profile.barcolor)
								end,
								set = function(info, r, g, b, a)
									self.db.profile.barcolor = {r, g, b, a}
									for i = 1, 20, 1 do
										local unitid = 'nameplate'..i
										self.targetframe[unitid].bar:SetStatusBarColor(unpack(self.db.profile.barcolor))
									end
									for i = 1, 5, 1 do
										local unitid = 'boss'..i
										self.targetframe[unitid].bar:SetStatusBarColor(unpack(self.db.profile.barcolor))
									end
								end,
							},
							clickoptions = {
								type = "group",
								desc = L["Mouseclicksopt"],
								order = 6,
								inline = true,
								name = L["Mouseclicks"],
								args = {
									rightclick = {
										name = L["right"],
										desc = L["Mouseclicksopt"],
										type = "input",
										set = function(info, value)
											UnrealTargets:update_click("right", value)
											if newvalue then
												self.db.profile.rightclick = value
											end
										end,
										get = function() return GetSpellInfo(tostring(self.db.profile.rightclick)) end,
										order = 2,
									},
									leftclick = {
										name = L["left"],
										desc = L["Mouseclicksopt"],
										type = "input",
										set = function(info, value)
											local newvalue = UnrealTargets:update_click("left", value) 
											if newvalue then
												self.db.profile.leftclick = value
											end
										end,
										get = function() return GetSpellInfo(tostring(self.db.profile.leftclick)) end,
										order = 1,
									},
								
								},
							}
						},
					},
				}
			}
			-- advance = {
			
			-- }
			
		}
	}
	self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UnrealTargets", UnrealTargets.options)
	
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UnrealTargets", "UnrealTargets", nil, "general")
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UnrealTargets", "Profiles", "UnrealTargets", "profiles")
end

function UnrealTargets:unit_health(...)
	local unitid = ...
	local name = GetUnitName(unitid)
	name = self:cut_name(name, 16)
	
	local nameplate_unitid = string.find(unitid, "nameplate") or string.find(unitid, "boss") or 0
	if nameplate_unitid == 1 then
		UnrealTargets.targetframe[unitid].fontname:SetText(name)
		local max_health = UnitHealthMax(unitid)
		local currenthealth = UnitHealth(unitid)
		local healthph = currenthealth / max_health * 100
		UnrealTargets.targetframe[unitid].bar:SetValue(healthph)
		healthph = string.format("%.1f", healthph)
		UnrealTargets.targetframe[unitid].fonthppercent:SetText(healthph)
	end
end

function UnrealTargets:name_plate_unit_added(...)
	local unitid = ...
	local guid = UnitGUID(...)
	self:check_auras(unitid)
	local name = GetUnitName(unitid)
	name = self:cut_name(name, 16)
	
	local nameplate_unitid = string.find(unitid, "nameplate") or string.find(unitid, "boss") or 0
	if nameplate_unitid == 1 then
		UnrealTargets.targetframe[unitid].fontname:SetText(name)
		local max_health = UnitHealthMax(unitid)
		local currenthealth = UnitHealth(unitid)
		local healthph = currenthealth / max_health * 100
		UnrealTargets.targetframe[unitid].bar:SetValue(healthph)
		healthph = string.format("%.1f", healthph)
		UnrealTargets.targetframe[unitid].fonthppercent:SetText(healthph)
		
	end
end

function UnrealTargets:hide_debuffs(unitid)
	local nameplate_unitid = string.find(unitid, "nameplate") or string.find(unitid, "boss") or 0
	if nameplate_unitid == 1 then
		for i= 1, 5, 1 do
			UnrealTargets.targetframe[unitid].debuffs['debuff'..i]:Hide()
		end
	end
end

function UnrealTargets:update_debuffs(unitid, guid, buffnumber, name, spellId, count, remaining_time, expirationTime)
	--print(unitid..' '..name..' '..string.format("%.1f", remaining_time)..' '..guid)	
	local nameplate_unitid = string.find(unitid, "nameplate") or string.find(unitid, "boss") or 0
	if nameplate_unitid == 1 then
		local icon = GetSpellTexture(spellId)
		local debuff = 'debuff'..buffnumber
		table.insert(UnrealTargets.debuffs, unitid..'|'..debuff..'|'..expirationTime)
		UnrealTargets.targetframe[unitid].debuffs[debuff]:Show()
		UnrealTargets.targetframe[unitid].debuffs[debuff]:SetNormalTexture(icon)
		UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration:SetText(string.format("%.1f", remaining_time))
		if count < 2 then
			UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount:SetText('')
		else
			UnrealTargets.targetframe[unitid].debuffs[debuff].fontcount:SetText(count)
		end
	end
end

function UnrealTargets:check_auras(unitid)
	--print('check unitid '..unitid)
	local localtime = GetTime()
	self:hide_debuffs(unitid)
	for i= 1, 5, 1 do
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3 = UnitDebuff(unitid, i,"PLAYER")
		if name then
			local remaining_time = expirationTime-localtime
			local guid = UnitGUID(unitid)
			self:update_debuffs(unitid, guid, i, name, spellId, count, remaining_time, expirationTime)
		end
	end
end

function UnrealTargets_OnUpdate(self, elapsed) 
	local localtime = GetTime()
	for i, mydebuffs in ipairs(UnrealTargets.debuffs) do
		local unitid, debuff, expirationTime = strsplit('|', mydebuffs)
		local remaining_time = expirationTime-localtime
		UnrealTargets.targetframe[unitid].debuffs[debuff].fonttextduration:SetText(string.format("%.1f", remaining_time))
		if remaining_time <= 0 then
			 table.remove(UnrealTargets.debuffs, i)
		end
	end
	for i, casting in ipairs(UnrealTargets.castingspells) do
		local unitid, endTime, duration = strsplit('|', casting)
		local remaining_time = endTime/1000-localtime
		local casthp = remaining_time / duration * 100
		UnrealTargets.targetframe[unitid].bar.castbar:SetValue(casthp)
		if remaining_time <= 0 then
			 table.remove(UnrealTargets.castingspells, i)
			 UnrealTargets.targetframe[unitid].bar.castbar:Hide()
		end
		remaining_time = string.format("%.1f", remaining_time)
		UnrealTargets.targetframe[unitid].bar.castbar.bartime:SetText(remaining_time)
	end
end

function UnrealTargets.frame:OnEvent(event, ...)
	UnrealTargets_OnUpdate()
	if event == 'UNIT_HEALTH_FREQUENT' then
		UnrealTargets:unit_health(...)
	elseif event == 'UNIT_AURA' then
		UnrealTargets:check_auras(...)
	elseif event == 'UNIT_SPELLCAST_START' then
		--self:unit_spellcast_start(...)
	elseif event == 'UNIT_SPELLCAST_CHANNEL_START' then
		--self:unit_spellcast_channel_start(...)
	elseif event == 'NAME_PLATE_CREATED' then
		--self:name_plate_created(...) -- return 1 table value ?!?
	elseif event == 'NAME_PLATE_UNIT_ADDED' then
		UnrealTargets:name_plate_unit_added(...)
	elseif event == 'NAME_PLATE_UNIT_REMOVED' then
		--self:name_plate_unit_removed(...)
	elseif event == 'ADDON_LOADED' then
		--self:mysettings(...)
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		--UnrealTargets.frame:COMBAT_LOG_EVENT_UNFILTERED(...)
	end
end

function OnEvent(self, event, ...)
	UnrealTargets.frame:OnEvent(event, ...)
end